import os

import axipy
from axipy import AxiomaPlugin, state_manager

from RotateMap.ui.MapRotate import MapRotate
from RotateMap.ui.docWidget import DelDocWidget


class Plugin(AxiomaPlugin):

    def load(self):
        self.__observer=state_manager.find(axipy.da.DefaultKeys.MapView)
        local_file_icon=os.path.join(os.path.dirname(os.path.realpath(__file__)),'ui/icons', 'map.png')
        self.__action = self.create_action('Поворот окна карты',
                                           icon=local_file_icon, on_click=self.__run,enable_on =axipy.da.DefaultKeys.MapView)
        position = self.get_position('Карта', 'Инструменты')
        position.add(self.__action)
        self.__cls_rotate=MapRotate(self)
        self.__observer.changed.connect(self.__changeActiveMap)
    def __run(self):
        self.__cls_rotate.run_rotate()
    def __changeActiveMap(self):
        self.__cls_rotate.changeActiveMap(self.__observer.value())
    def unload(self):
        #self.__action.remove()
        if self.__cls_rotate is not None:
            doc_widget=self.__cls_rotate.docWidget
            self.__removeWidget(doc_widget)
    def __removeWidget(self,doc):
        if doc is None:
            return
        DelDocWidget(axipy.app.mainwindow.qt_object(),doc)
        doc=None