import os

import axipy
from PySide2.QtGui import QIcon
from axipy import view_manager, state_manager

from RotateMap.ui.FormRotatemap import FormRotateMap
from RotateMap.ui.docWidget import DelDocWidget, AxiDocWidget, addDoc, existDocWidget
from RotateMap.ui.tools.observers import factoryObserverActiveMap


class MapRotate:
    __name='Поворот окна карты'
    __name_observer='ViewMapActive'
    __type_observer="catalog"
    __form_tool=None
    __docWidget=None
    __def_name_group="Инструменты"
    def __init__(self,parentPlugin):
        self.__parentCls=parentPlugin
        #self._initTool(parentPlugin)
    def _initTool(self,parentPlugin):
        #self.__observer=factoryObserverActiveMap(self.__name_observer)
        self.__observer=state_manager.find(axipy.da.DefaultKeys.MapView)

        local_file_icon=os.path.join(os.path.dirname(os.path.realpath(__file__)),'icons', 'world-map-32.png')
        try:
            #self.__action=parentPlugin.create_action(self.__name,icon=local_file_icon, on_click=self.__run_rotate,enable_on = self.__name_observer)
            #self.__action=parentPlugin.create_action(self.__name,icon=local_file_icon, on_click=self.__run_rotate)
            self.__action=parentPlugin.create_action(self.__name,icon=local_file_icon, on_click=self.run)
        except Exception as ex:
            jkl=0
        self.__observer.changed.connect(self.__changeActiveMap)
        return
    def run(self):
        jkl=0
    def run_rotate(self):
        print("Click run")
        if self.__form_tool is None:

            self.__form_tool=self.__form_tool= FormRotateMap(axipy.app.mainwindow.qt_object())
            self.__form_tool.updateActiveMap(view_manager.active)
            #self.__observer.addChildrenWidget("RotateMap",self.__form_tool)
        if self.__docWidget is None:

            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"RotateMap",self.__name,QIcon(),axipy.app.mainwindow.qt_object())
            addDoc(axipy.app.mainwindow.qt_object(),self.__docWidget)
        else:

            isExist=existDocWidget(axipy.app.mainwindow.qt_object(),self.__docWidget)
            try:
                self.__docWidget.setVisible(True)
                self.__docWidget.setFocus()
                self.__docWidget.raise_()
            except:
                if self.__form_tool is not None:
                    self.__form_tool = self.__form_tool = FormRotateMap(axipy.app.mainwindow.qt_object())
                    self.__form_tool.updateActiveMap(view_manager.active)
                    self.__docWidget = AxiDocWidget(self.__form_tool.widget, "RotateMap", self.__name, QIcon(),
                                                    axipy.app.mainwindow.qt_object())
                    addDoc(axipy.app.mainwindow.qt_object(), self.__docWidget)

    def changeActiveMap(self,value=None):
        value_observer=value
        if value is None:
            value_observer=self.__observer.value()
        if not value_observer:
            if self.__docWidget is not None:
                DelDocWidget(axipy.app.mainwindow.qt_object(),self.__docWidget)
                #self.__observer.removeChildrenWidget(self.__name_observer)

                self.__docWidget=None
                self.__form_tool=None
                return
        if self.__docWidget is not None:

            self.__form_tool= FormRotateMap(axipy.app.mainwindow.qt_object())
            self.__form_tool.updateActiveMap(view_manager.active)
            self.__observer.addChildrenWidget(self.__name_observer,self.__form_tool)
            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"RotateMap",self.__name,QIcon(),axipy.app.mainwindow.qt_object())
            addDoc(axipy.app.mainwindow.qt_object(),self.__docWidget)
    @property
    def name(self):
        return self.__name
    @property
    def name_group(self):
        return self.__def_name_group
    @property
    def action(self):
        return self.__action
    @property
    def nameObserver(self):
        return self.__name_observer
    @property
    def typeObserver(self):
        return self.__type_observer
    @property
    def docWidget(self):
        return self.__docWidget
    @property
    def form(self):
        return self.__form_tool