import math

from axipy import CoordSystem, Point


def calcAffineMapInfo(fCenterX,fCenterY,fAngle):
    fAngleRadian=math.radians(fAngle)
    origx=[0]*3
    origy=[0]*3
    newx=[0]*3
    newy=[0]*3
    origx[0] = fCenterX
    origy[0] = fCenterY
    origx[1] = fCenterX
    if fCenterY!=0.0:
        origy[1] = 0.0
    else:
        pass
        #origy(2) = MapperInfo(FrontWindow(), MAPPER_INFO_MAXY)
    if fCenterX!=0.0:
        origx[2] = 0.0
    else:
        pass
        #origx(3) = MapperInfo(FrontWindow(), MAPPER_INFO_MAXX)
    origy[2] = fCenterY
    newx[0] = fCenterX
    newy[0] = fCenterY
    if fCenterY!=0.0:
        newx[1] = origx[0]+(origy[0]*math.sin(-fAngleRadian))
        newy[1] = origy[0]-(origy[0]*math.sin(math.radians(90+fAngle)))
    else:
        newx[1] = origx[0]-(origy[1]*math.sin(-fAngleRadian))
        newy[1] = origy[0]+(origy[1]*math.sin(math.radians(90+fAngle)))
    if fCenterX!=0.0:
        newx[2] = origx[0]-(origx[0]*math.sin(math.radians(90+fAngle)))
        newy[2] = origy[0]-(origx[0]*math.sin(-fAngleRadian))
    else:
        newx[2] = origx[0]+(origx[2]*math.sin(math.radians(90+fAngle)))
        newy[2] = origy[0]+(origx[2]*math.sin(-fAngleRadian))

    s=[0]*9
    beta=[0]*7
    avgx = 0
    avgy = 0
    for i in range(3):
        avgx = avgx + newx[i]
        avgy = avgy + newy[i]
    avgx = avgx / 3
    avgy = avgy / 3
    jkl=0
    for i in range(3):
        s[0] = s[0] + (newx[i] - avgx) * (newy[i] - avgy)
        s[1] = s[1] + (newy[i] - avgy) * (newy[i] - avgy)
        s[2] = s[2] + (newx[i] - avgx) * (newx[i] - avgx)

        s[3] = s[3] + (newy[i] - avgy) * (origy[i] - newy[i])

        s[4] = s[4] + (newx[i] - avgx) * (origx[i] - newx[i])
        s[5] = s[5] + (newx[i] - avgx) * (origy[i] - newy[i])
        s[6] = s[6] + (newy[i] - avgy) * (origx[i] - newx[i])
        s[7] = s[7] + origx[i] - newx[i]
        s[8] = s[8] + origy[i] - newy[i]
    if s[1]==0.0 or s[2]==0.0:
        return None
    p = s[0] / s[1]
    q = s[0] / s[2]
    temp = s[2] - p * s[0]
    if temp==0.0:
        return None
    beta[3] = (s[5] - p * s[3]) / temp
    temp = s[1] - q * s[0]
    if temp==0.0:
        return None
    beta[1] = (s[6] - q * s[4]) / temp
    beta[4] = 1 - p * beta[3] + s[3] / s[1]
    beta[0] = 1 - q * beta[1] + s[4] / s[2]
    beta[2] = s[7] / 3 + avgx - beta[0] * avgx - beta[1] * avgy
    beta[5] = s[8] / 3 + avgy - beta[4] * avgy - beta[3] * avgx
    temp = beta[4] * beta[0] - beta[3] * beta[1]
    if temp==0.0:
        return None
    aa = beta[4] / temp
    ab = -beta[1] / temp
    ac = (beta[1] * beta[5] - beta[2] * beta[4]) / temp
    ad = -beta[3] / temp
    ae = beta[0] / temp
    af = (beta[3] * beta[2] - beta[5] * beta[0]) / temp
    return [aa,ab,ac,ad,ae,af]

class Rotate:
    def __init__(self):
        self.__cs4326=CoordSystem.from_epsg(4326)
    def center(self,map_view):
        center=map_view.center
        pt_use_center=Point(center.x,center.y,map_view.coordsystem)
        if map_view.coordsystem!=self.__cs4326:
            pt_use_center=pt_use_center.reproject(self.__cs4326)
        return pt_use_center